/*-
 * ~~~~~~licensing~~~~~~
 * system-group-api
 * ==========
 * Copyright (C) 2020 - 2024 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.groups.registry.jpa.entity;

import javax.persistence.*;
import java.util.Objects;

@Entity
@Table(name = "system_method_registry")
public class SystemGroupMethodRegistry {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private long id;

    @Column(name = "method_name")
    private String methodName;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "id_system_group_registry", referencedColumnName = "id")
    private SystemGroupRegistry systemGroupRegistry;

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public String getMethodName() {
        return methodName;
    }

    public void setMethodName(String methodName) {
        this.methodName = methodName;
    }

    public SystemGroupRegistry getSystemGroupRegistry() {
        return systemGroupRegistry;
    }

    public void setSystemGroupRegistry(SystemGroupRegistry systemGroupRegistry) {
        this.systemGroupRegistry = systemGroupRegistry;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, methodName, systemGroupRegistry);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        SystemGroupMethodRegistry other = (SystemGroupMethodRegistry) obj;
        return id == other.id && Objects.equals(methodName, other.methodName);
    }

    @Override
    public String toString() {
        return "SystemGroupMethodRegistry [id=" + id + ", methodName=" + methodName + "]";
    }

}
